var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _App_plugins, _App_rafId;
import { system, System, World } from '@lastolivegames/becsy';
import { DOMAdapter } from './environment';
import { StartUp, First, Last, PostUpdate, Update, PreStartUp, PostStartUp, PreUpdate, } from './systems/stages';
/**
 * @see https://bevy-cheatbook.github.io/programming/app-builder.html
 */
export class App {
    constructor() {
        /**
         * All the plugins registered.
         */
        _App_plugins.set(this, []);
        _App_rafId.set(this, void 0);
    }
    /**
     * @example
     * new App()
     *   .addPlugin(P1)
     */
    addPlugin(plugin) {
        __classPrivateFieldGet(this, _App_plugins, "f").push(plugin);
        return this;
    }
    /**
     * @example
     * new App()
     *   .addPlugins(P1, P2)
     */
    addPlugins(...plugins) {
        plugins.forEach((plugin) => {
            this.addPlugin(plugin);
        });
        return this;
    }
    /**
     * Start the app and run all systems.
     */
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            // Create a global init system.
            let PreStartUpPlaceHolder = class PreStartUpPlaceHolder extends System {
            };
            PreStartUpPlaceHolder = __decorate([
                system(PreStartUp)
            ], PreStartUpPlaceHolder);
            let StartUpPlaceHolder = class StartUpPlaceHolder extends System {
            };
            StartUpPlaceHolder = __decorate([
                system(StartUp)
            ], StartUpPlaceHolder);
            let PostStartUpPlaceHolder = class PostStartUpPlaceHolder extends System {
            };
            PostStartUpPlaceHolder = __decorate([
                system(PostStartUp)
            ], PostStartUpPlaceHolder);
            let PreUpdatePlaceHolder = class PreUpdatePlaceHolder extends System {
            };
            PreUpdatePlaceHolder = __decorate([
                system(PreUpdate)
            ], PreUpdatePlaceHolder);
            let UpdatePlaceHolder = class UpdatePlaceHolder extends System {
            };
            UpdatePlaceHolder = __decorate([
                system(Update)
            ], UpdatePlaceHolder);
            let PostUpdatePlaceHolder = class PostUpdatePlaceHolder extends System {
            };
            PostUpdatePlaceHolder = __decorate([
                system(PostUpdate)
            ], PostUpdatePlaceHolder);
            let FirstPlaceHolder = class FirstPlaceHolder extends System {
            };
            FirstPlaceHolder = __decorate([
                system(First)
            ], FirstPlaceHolder);
            let LastPlaceHolder = class LastPlaceHolder extends System {
            };
            LastPlaceHolder = __decorate([
                system(Last)
            ], LastPlaceHolder);
            // Build all plugins.
            for (const plugin of __classPrivateFieldGet(this, _App_plugins, "f")) {
                if (Array.isArray(plugin)) {
                    yield plugin[0](plugin[1]);
                }
                else {
                    yield plugin();
                }
            }
            // Create world.
            // All systems will be instantiated and initialized before the returned promise resolves.
            this.world = yield World.create({
                // Multithreading is not supported yet.
                threads: 1,
            });
            const tick = () => __awaiter(this, void 0, void 0, function* () {
                yield this.world.execute();
                __classPrivateFieldSet(this, _App_rafId, DOMAdapter.get().requestAnimationFrame(tick), "f");
            });
            __classPrivateFieldSet(this, _App_rafId, DOMAdapter.get().requestAnimationFrame(tick), "f");
            return this;
        });
    }
    /**
     * Exit the app.
     * @see https://bevy-cheatbook.github.io/programming/app-builder.html#quitting-the-app
     */
    exit() {
        return __awaiter(this, void 0, void 0, function* () {
            DOMAdapter.get().cancelAnimationFrame(__classPrivateFieldGet(this, _App_rafId, "f"));
            yield this.world.terminate();
        });
    }
}
_App_plugins = new WeakMap(), _App_rafId = new WeakMap();
//# sourceMappingURL=App.js.map