import { Bundle } from '../components';
/**
 * A [`Command`] that adds the components in a [`Bundle`] to an entity.
 */
export class Insert {
    constructor(id, bundles) {
        this.id = id;
        this.bundles = bundles;
    }
    apply(system) {
        this.bundles.forEach((bundle) => {
            this.addBundle(bundle);
        });
    }
    addBundle(bundle) {
        // Add bundle.
        if (bundle instanceof Bundle) {
            Object.keys(bundle).forEach((key) => {
                if (bundle[key] instanceof Bundle) {
                    this.addBundle(bundle[key]);
                }
                else if (bundle[key]) {
                    // @ts-ignore
                    this.id.add(bundle[key].constructor, bundle[key]);
                }
            });
        }
        else {
            // Add component.
            // @ts-ignore
            this.id.add(bundle.constructor, bundle);
        }
    }
}
//# sourceMappingURL=Insert.js.map