var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, Type } from '@lastolivegames/becsy';
import { Camera } from './camera/Camera';
import { InputPoint } from './Input';
import { RasterScreenshotRequest, Screenshot, VectorScreenshotRequest, } from './Screenshot';
export var Pen;
(function (Pen) {
    Pen["SELECT"] = "select";
    Pen["HAND"] = "hand";
    Pen["DRAW_RECT"] = "draw-rect";
})(Pen || (Pen = {}));
export class Canvas {
    constructor(canvas) {
        Object.assign(this, canvas);
    }
}
__decorate([
    field.object
], Canvas.prototype, "element", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Canvas.prototype, "width", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Canvas.prototype, "height", void 0);
__decorate([
    field({ type: Type.staticString(['webgl', 'webgpu']), default: 'webgl' })
], Canvas.prototype, "renderer", void 0);
__decorate([
    field.object
], Canvas.prototype, "shaderCompilerPath", void 0);
__decorate([
    field({ type: Type.float32, default: 1 })
], Canvas.prototype, "devicePixelRatio", void 0);
__decorate([
    field({
        type: Type.staticString([Pen.SELECT, Pen.HAND, Pen.DRAW_RECT]),
        default: Pen.HAND,
    })
], Canvas.prototype, "pen", void 0);
__decorate([
    field.backrefs(Camera, 'canvas')
], Canvas.prototype, "cameras", void 0);
__decorate([
    field.backrefs(InputPoint, 'canvas')
], Canvas.prototype, "inputPoints", void 0);
__decorate([
    field.backrefs(Screenshot, 'canvas')
], Canvas.prototype, "screenshots", void 0);
__decorate([
    field.backrefs(VectorScreenshotRequest, 'canvas')
], Canvas.prototype, "vectorScreenshotRequests", void 0);
__decorate([
    field.backrefs(RasterScreenshotRequest, 'canvas')
], Canvas.prototype, "rasterScreenshotRequests", void 0);
//# sourceMappingURL=Canvas.js.map