import { Entity } from '@lastolivegames/becsy';
export type DataURLType = 'image/png' | 'image/jpeg' | 'image/webp' | 'image/bmp';
export declare class RasterScreenshotRequest {
    /**
     * The default type is image/png.
     */
    type: DataURLType;
    /**
     * The image quality between 0 and 1 for image/jpeg and image/webp.
     */
    encoderOptions: number;
    /**
     * Whether to draw grid on the image.
     */
    grid: boolean;
    /**
     * Whether to take a screenshot.
     */
    enabled: boolean;
    /**
     * Canvas target.
     */
    canvas: Entity;
}
export declare class VectorScreenshotRequest {
    /**
     * Whether to draw grid on the image.
     */
    grid: boolean;
    /**
     * Whether to take a screenshot.
     */
    enabled: boolean;
    /**
     * Canvas target.
     */
    canvas: Entity;
}
export declare class Screenshot {
    dataURL: string;
    /**
     * Canvas target.
     */
    canvas: Entity;
}
