export declare enum ThemeMode {
    LIGHT = "light",
    DARK = "dark"
}
interface ThemeColors {
    /**
     * Background color of page.
     */
    background: string;
    /**
     * Color of grid.
     */
    grid: string;
    /**
     * Fill color of the selection brush.
     */
    selectionBrushFill: string;
    /**
     * Stroke color of the selection brush.
     */
    selectionBrushStroke: string;
}
export declare class Theme {
    /**
     * Theme.
     */
    mode: ThemeMode;
    /**
     * Theme colors.
     * @see https://github.com/dgmjs/dgmjs/blob/main/packages/core/src/colors.ts#L130
     */
    colors: Partial<{
        [ThemeMode.LIGHT]: Partial<ThemeColors>;
        [ThemeMode.DARK]: Partial<ThemeColors>;
    }>;
}
export {};
