import { AABB } from '../math';
import { Stroke } from '../renderable';
/**
 * @see https://docs.rs/bevy/latest/bevy/math/prelude/struct.Circle.html
 */
export declare class Circle {
    static getGeometryBounds(circle: Circle): AABB;
    static getRenderBounds(circle: Circle, stroke?: Stroke): AABB;
    /**
     * The cx attribute define the x-axis coordinate of a center point.
     *
     * Default value is `0`.
     * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/cx
     */
    cx: number;
    /**
     * The cy attribute define the y-axis coordinate of a center point.
     *
     * Default value is `0`.
     * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/cy
     */
    cy: number;
    /**
     * The r attribute defines the radius of a circle.
     *
     * Default value is `0`.
     */
    r: number;
    constructor(props?: Partial<Circle>);
}
