var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, Type } from '@lastolivegames/becsy';
import { AABB } from '../math';
import { strokeOffset } from '../../utils';
/**
 * @see https://docs.rs/bevy/latest/bevy/math/prelude/struct.Circle.html
 */
export class Circle {
    static getGeometryBounds(circle) {
        const { cx, cy, r } = circle;
        return new AABB(cx - r, cy - r, cx + r, cy + r);
    }
    static getRenderBounds(circle, stroke) {
        const { cx, cy, r } = circle;
        const offset = strokeOffset(stroke);
        return new AABB(cx - r - offset, cy - r - offset, cx + r + offset, cy + r + offset);
    }
    constructor(props) {
        this.cx = props === null || props === void 0 ? void 0 : props.cx;
        this.cy = props === null || props === void 0 ? void 0 : props.cy;
        this.r = props === null || props === void 0 ? void 0 : props.r;
    }
}
__decorate([
    field({ type: Type.float32, default: 0 })
], Circle.prototype, "cx", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Circle.prototype, "cy", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Circle.prototype, "r", void 0);
//# sourceMappingURL=Circle.js.map