var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, Type } from '@lastolivegames/becsy';
import { AABB } from '../math';
import { strokeOffset } from '../../utils';
/**
 * Used to create ellipses based on a center coordinate, and both their x and y radius.
 * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Element/ellipse
 */
export class Ellipse {
    static getGeometryBounds(ellipse) {
        const { cx, cy, rx, ry } = ellipse;
        return new AABB(cx - rx, cy - ry, cx + rx, cy + ry);
    }
    static getRenderBounds(ellipse, stroke) {
        const { cx, cy, rx, ry } = ellipse;
        const offset = strokeOffset(stroke);
        return new AABB(cx - rx - offset, cy - ry - offset, cx + rx + offset, cy + ry + offset);
    }
    constructor(props) {
        this.cx = props === null || props === void 0 ? void 0 : props.cx;
        this.cy = props === null || props === void 0 ? void 0 : props.cy;
        this.rx = props === null || props === void 0 ? void 0 : props.rx;
        this.ry = props === null || props === void 0 ? void 0 : props.ry;
    }
}
__decorate([
    field({ type: Type.float32, default: 0 })
], Ellipse.prototype, "cx", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Ellipse.prototype, "cy", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Ellipse.prototype, "rx", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Ellipse.prototype, "ry", void 0);
//# sourceMappingURL=Ellipse.js.map