var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, Type } from '@lastolivegames/becsy';
import { AABB } from '../math';
import { strokeOffset } from '../../utils';
/**
 * Defined by its position, width, and height. The rectangle may have its corners rounded.
 * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Element/rect
 */
export class Rect {
    static getGeometryBounds(rect) {
        const { x, y, width, height } = rect;
        return new AABB(Math.min(x, x + width), Math.min(y, y + height), Math.max(x, x + width), Math.max(y, y + height));
    }
    static getRenderBounds(rect, stroke, dropShadow) {
        const { x, y, width, height } = rect;
        const { offsetX = 0, offsetY = 0, blurRadius = 0 } = dropShadow !== null && dropShadow !== void 0 ? dropShadow : {};
        const offset = strokeOffset(stroke);
        const renderBounds = new AABB(x - offset, y - offset, x + width + offset, y + height + offset);
        renderBounds.addBounds(new AABB(x + offsetX - blurRadius, y + offsetY - blurRadius, x + offsetX + width + blurRadius, y + offsetY + height + blurRadius));
        return renderBounds;
    }
    constructor(props) {
        this.x = props === null || props === void 0 ? void 0 : props.x;
        this.y = props === null || props === void 0 ? void 0 : props.y;
        this.width = props === null || props === void 0 ? void 0 : props.width;
        this.height = props === null || props === void 0 ? void 0 : props.height;
        this.cornerRadius = props === null || props === void 0 ? void 0 : props.cornerRadius;
    }
}
__decorate([
    field({ type: Type.float32, default: 0 })
], Rect.prototype, "x", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Rect.prototype, "y", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Rect.prototype, "width", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Rect.prototype, "height", void 0);
__decorate([
    field({ type: Type.float32, default: 0 })
], Rect.prototype, "cornerRadius", void 0);
//# sourceMappingURL=Rect.js.map