import { Type } from '@lastolivegames/becsy';
/**
 * A 3-dimensional vector.
 *
 * @see https://lastolivegames.github.io/becsy/guide/architecture/components#numeric-vectors
 */
export declare class Vec3 {
    static ZERO: Vec3;
    static ONE: Vec3;
    static MAX: Vec3;
    static MIN: Vec3;
    static NEG_Z: Vec3;
    static X: Vec3;
    static Y: Vec3;
    static Z: Vec3;
    static splat(v: number): Vec3;
    /**
     * Creates a new vector from an array.
     */
    static from_array(a: [number, number, number]): Vec3;
    static copy(a: Vec3): Vec3;
    x: number;
    y: number;
    z: number;
    constructor(x?: number, y?: number, z?: number);
    xxx(): Vec3;
    yyy(): Vec3;
    zzz(): Vec3;
    add(rhs: number | Vec3): Vec3;
    mul(rhs: number | Vec3): Vec3;
}
export declare const v3Type: Type<number[]>;
