export declare class DropShadow {
    /**
     * Specifies color for the shadow.
     * @see https://developer.mozilla.org/en-US/docs/Web/CSS/filter-function/drop-shadow#color
     */
    color: string;
    /**
     * Horizontal offset.
     *
     * Default to `0`.
     * @see https://developer.mozilla.org/en-US/docs/Web/CSS/filter-function/drop-shadow
     */
    offsetX: number;
    /**
     * Vertical offset
     * @see https://developer.mozilla.org/en-US/docs/Web/CSS/filter-function/drop-shadow
     */
    offsetY: number;
    /**
     * The larger this value, the bigger the blur, so the shadow becomes bigger and lighter.
     * Negative values are not allowed.
     *
     * Default to `0`.
     * @see https://developer.mozilla.org/en-US/docs/Web/CSS/filter-function/drop-shadow
     */
    blurRadius: number;
    constructor(props?: Partial<DropShadow>);
}
