export declare class Opacity {
    /**
     * It specifies the transparency of an object or of a group of objects,
     * that is, the degree to which the background behind the element is overlaid.
     *
     * Default value is `1`.
     * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/opacity
     */
    opacity: number;
    /**
     * It is a presentation attribute defining the opacity of the paint server (color, gradient, pattern, etc.) applied to the stroke of a shape.
     *
     * Default value is `1`.
     * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/stroke-opacity
     */
    strokeOpacity: number;
    /**
     * It is a presentation attribute defining the opacity of the paint server (color, gradient, pattern, etc.) applied to a shape.
     *
     * Default value is `1`.
     * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/fill-opacity
     */
    fillOpacity: number;
    constructor(props?: Partial<Opacity>);
}
