var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { field, Type } from '@lastolivegames/becsy';
import { Stroke } from './Stroke';
import { FillSolid } from './Fill';
import { filterUndefined } from '../../utils';
export class Rough {
}
__decorate([
    field({ type: Type.float32, default: 1 })
], Rough.prototype, "seed", void 0);
__decorate([
    field({ type: Type.float32, default: 1 })
], Rough.prototype, "roughness", void 0);
__decorate([
    field({ type: Type.float32, default: 1 })
], Rough.prototype, "bowing", void 0);
__decorate([
    field({
        type: Type.staticString([
            'hachure',
            'solid',
            'zigzag',
            'cross-hatch',
            'dots',
            'dashed',
            'zigzag-line',
        ]),
        default: 'hachure',
    })
], Rough.prototype, "fillStyle", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "fillWeight", void 0);
__decorate([
    field({ type: Type.float32, default: -41 })
], Rough.prototype, "hachureAngle", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "hachureGap", void 0);
__decorate([
    field({ type: Type.float32, default: 9 })
], Rough.prototype, "curveStepCount", void 0);
__decorate([
    field({ type: Type.float32, default: 0.95 })
], Rough.prototype, "curveFitting", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "fillLineDash", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "fillLineDashOffset", void 0);
__decorate([
    field({ type: Type.boolean, default: false })
], Rough.prototype, "disableMultiStroke", void 0);
__decorate([
    field({ type: Type.boolean, default: false })
], Rough.prototype, "disableMultiStrokeFill", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "simplification", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "dashOffset", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "dashGap", void 0);
__decorate([
    field({ type: Type.float32 })
], Rough.prototype, "zigzagOffset", void 0);
__decorate([
    field({ type: Type.boolean, default: false })
], Rough.prototype, "preserveVertices", void 0);
export class ComputedRough {
}
__decorate([
    field({ type: Type.object, default: [] })
], ComputedRough.prototype, "strokePoints", void 0);
__decorate([
    field({ type: Type.object, default: [] })
], ComputedRough.prototype, "fillPoints", void 0);
__decorate([
    field({ type: Type.object, default: [] })
], ComputedRough.prototype, "fillPathPoints", void 0);
__decorate([
    field({ type: Type.object })
], ComputedRough.prototype, "drawableSets", void 0);
export function getRoughOptions(entity) {
    const rough = entity.read(Rough);
    const fillComponent = entity.has(FillSolid)
        ? entity.read(FillSolid)
        : { value: 'none' };
    const strokeComponent = entity.has(Stroke)
        ? entity.read(Stroke)
        : { color: 'none', width: 0, dasharray: [], dashoffset: 0 };
    const { color, width, dasharray, dashoffset } = strokeComponent;
    const { value: fill } = fillComponent;
    const { seed, bowing, roughness, fillStyle, fillWeight, hachureAngle, hachureGap, curveStepCount, curveFitting, disableMultiStroke, disableMultiStrokeFill, simplification, dashOffset, dashGap, zigzagOffset, preserveVertices, fillLineDash, fillLineDashOffset, } = rough;
    return filterUndefined({
        fill,
        stroke: color,
        strokeWidth: width,
        seed,
        bowing,
        roughness,
        fillStyle,
        fillWeight,
        hachureAngle,
        hachureGap,
        curveStepCount,
        curveFitting,
        disableMultiStroke,
        disableMultiStrokeFill,
        simplification,
        dashOffset,
        dashGap,
        zigzagOffset,
        preserveVertices,
        strokeLineDash: dasharray,
        strokeLineDashOffset: dashoffset,
        fillLineDash,
        fillLineDashOffset,
    });
}
//# sourceMappingURL=Rough.js.map