export const WebWorkerAdapter = {
    createCanvas: (width, height) => new OffscreenCanvas(width !== null && width !== void 0 ? width : 0, height !== null && height !== void 0 ? height : 0),
    createTexImageSource: (canvas) => canvas,
    getDocument: () => null,
    /**
     * @see https://stackoverflow.com/questions/33641622/dom-manipulation-inside-web-worker
     */
    getXMLSerializer: () => null,
    getDOMParser: () => null,
    splitGraphemes: (s) => {
        if (typeof (Intl === null || Intl === void 0 ? void 0 : Intl.Segmenter) === 'function') {
            const segmenter = new Intl.Segmenter();
            return [...segmenter.segment(s)].map((x) => x.segment);
        }
        return [...s];
    },
    requestAnimationFrame: (callback) => requestAnimationFrame(callback),
    cancelAnimationFrame: (id) => cancelAnimationFrame(id),
};
//# sourceMappingURL=WebWorkerAdapter.js.map