export interface Adapter {
    createCanvas: (width?: number, height?: number) => HTMLCanvasElement | OffscreenCanvas;
    createTexImageSource: (canvas: HTMLCanvasElement | OffscreenCanvas) => TexImageSource;
    getDocument: () => Document;
    getXMLSerializer: () => XMLSerializer | null;
    getDOMParser: () => DOMParser | null;
    splitGraphemes: (s: string) => string[];
    requestAnimationFrame: (callback: FrameRequestCallback) => number;
    cancelAnimationFrame: (handle: number) => void;
}
export declare const DOMAdapter: {
    /**
     * Returns the current adapter.
     */
    get(): Adapter;
    /**
     * Sets the current adapter.
     */
    set(adapter: Adapter): void;
};
