import { Buffer, Device, RenderPass } from '@antv/g-device-api';
import { Entity } from '@lastolivegames/becsy';
import { TexturePool } from '../resources';
import { RenderCache } from '../utils';
export declare class BatchManager {
    #private;
    private readonly device;
    private readonly renderCache;
    private readonly texturePool;
    constructor(device: Device, renderCache: RenderCache, texturePool: TexturePool);
    private collectDrawcallCtors;
    private createDrawcalls;
    private getOrCreateNonBatchableDrawcalls;
    private getOrCreateBatchableDrawcalls;
    add(shape: Entity): void;
    /**
     * Called when a shape is:
     * * removed from the scene graph.
     * * culled from viewport.
     * * invisible.
     */
    remove(shape: Entity): void;
    destroy(): void;
    clear(): void;
    flush(renderPass: RenderPass, uniformBuffer: Buffer, uniformLegacyObject: Record<string, unknown>): void;
    stats(): {
        drawcallCount: number;
    };
}
