import { System } from '@lastolivegames/becsy';
import { IPointData } from '@pixi/math';
/**
 * This system will bind event listeners to the canvas.
 * It will also handle the pointer events and keyboard events.
 */
export declare class EventWriter extends System {
    #private;
    private readonly canvases;
    private readonly pointerIds;
    private setInputTrigger;
    constructor();
    execute(): void;
    private bindEventListeners;
    /**
     * Should account for CSS Transform applied on container.
     * @see https://github.com/antvis/G/issues/1161
     * @see https://github.com/antvis/G/issues/1677
     * @see https://developer.mozilla.org/zh-CN/docs/Web/API/MouseEvent/offsetX
     */
    client2Viewport({ x, y }: IPointData, $el: HTMLCanvasElement): IPointData;
    viewport2Client({ x, y }: IPointData, $el: HTMLCanvasElement): IPointData;
    private getScale;
}
