var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _GridRenderer_program, _GridRenderer_pipeline, _GridRenderer_inputLayout, _GridRenderer_bindings, _GridRenderer_buffer, _GridRenderer_vertices;
import { VertexStepMode, Format, PrimitiveTopology, BufferUsage, BufferFrequencyHint, } from '@antv/g-device-api';
import { vert, frag } from '../shaders/grid';
import { DataArray } from '../utils';
export class GridRenderer {
    constructor() {
        _GridRenderer_program.set(this, void 0);
        _GridRenderer_pipeline.set(this, void 0);
        _GridRenderer_inputLayout.set(this, void 0);
        _GridRenderer_bindings.set(this, void 0);
        _GridRenderer_buffer.set(this, void 0);
        _GridRenderer_vertices.set(this, new DataArray());
    }
    appendVertex(x, y) {
        __classPrivateFieldGet(this, _GridRenderer_vertices, "f").appendFloat(x).appendFloat(y);
    }
    render(device, renderPass, uniformBuffer, uniformLegacyObject) {
        if (!__classPrivateFieldGet(this, _GridRenderer_program, "f")) {
            __classPrivateFieldSet(this, _GridRenderer_program, device.createProgram({
                vertex: {
                    glsl: vert,
                },
                fragment: {
                    glsl: frag,
                },
            }), "f");
            __classPrivateFieldSet(this, _GridRenderer_inputLayout, device.createInputLayout({
                vertexBufferDescriptors: [
                    {
                        arrayStride: 4 * 2,
                        stepMode: VertexStepMode.VERTEX,
                        attributes: [
                            {
                                format: Format.F32_RG,
                                offset: 0,
                                shaderLocation: 0,
                            },
                        ],
                    },
                ],
                indexBufferFormat: null,
                program: __classPrivateFieldGet(this, _GridRenderer_program, "f"),
            }), "f");
            __classPrivateFieldSet(this, _GridRenderer_pipeline, device.createRenderPipeline({
                inputLayout: __classPrivateFieldGet(this, _GridRenderer_inputLayout, "f"),
                program: __classPrivateFieldGet(this, _GridRenderer_program, "f"),
                colorAttachmentFormats: [Format.U8_RGBA_RT],
                depthStencilAttachmentFormat: Format.D24_S8,
                topology: PrimitiveTopology.TRIANGLE_STRIP,
            }), "f");
            __classPrivateFieldGet(this, _GridRenderer_vertices, "f").clear();
            this.appendVertex(-1, -1);
            this.appendVertex(-1, 1);
            this.appendVertex(1, -1);
            this.appendVertex(1, 1);
            const data = __classPrivateFieldGet(this, _GridRenderer_vertices, "f").bytes();
            const buffer = device.createBuffer({
                viewOrSize: data.byteLength,
                usage: BufferUsage.VERTEX,
                hint: BufferFrequencyHint.DYNAMIC,
            });
            __classPrivateFieldSet(this, _GridRenderer_buffer, buffer, "f");
            buffer.setSubData(0, data);
            __classPrivateFieldSet(this, _GridRenderer_bindings, device.createBindings({
                pipeline: __classPrivateFieldGet(this, _GridRenderer_pipeline, "f"),
                uniformBufferBindings: [
                    {
                        buffer: uniformBuffer,
                    },
                ],
            }), "f");
        }
        __classPrivateFieldGet(this, _GridRenderer_program, "f").setUniformsLegacy(uniformLegacyObject);
        renderPass.setBindings(__classPrivateFieldGet(this, _GridRenderer_bindings, "f"));
        renderPass.setPipeline(__classPrivateFieldGet(this, _GridRenderer_pipeline, "f"));
        renderPass.setVertexInput(__classPrivateFieldGet(this, _GridRenderer_inputLayout, "f"), [
            {
                buffer: __classPrivateFieldGet(this, _GridRenderer_buffer, "f"),
            },
        ], null);
        renderPass.draw(4);
    }
    destroy() {
        var _a, _b, _c, _d, _e;
        (_a = __classPrivateFieldGet(this, _GridRenderer_program, "f")) === null || _a === void 0 ? void 0 : _a.destroy();
        (_b = __classPrivateFieldGet(this, _GridRenderer_buffer, "f")) === null || _b === void 0 ? void 0 : _b.destroy();
        (_c = __classPrivateFieldGet(this, _GridRenderer_pipeline, "f")) === null || _c === void 0 ? void 0 : _c.destroy();
        (_d = __classPrivateFieldGet(this, _GridRenderer_inputLayout, "f")) === null || _d === void 0 ? void 0 : _d.destroy();
        (_e = __classPrivateFieldGet(this, _GridRenderer_bindings, "f")) === null || _e === void 0 ? void 0 : _e.destroy();
    }
}
_GridRenderer_program = new WeakMap(), _GridRenderer_pipeline = new WeakMap(), _GridRenderer_inputLayout = new WeakMap(), _GridRenderer_bindings = new WeakMap(), _GridRenderer_buffer = new WeakMap(), _GridRenderer_vertices = new WeakMap();
//# sourceMappingURL=GridRenderer.js.map