import { System } from '@lastolivegames/becsy';
import { Canvas, Cursor } from '../components';
export class SetCursor extends System {
    constructor() {
        super();
        this.cursors = this.query((q) => q.addedOrChanged.with(Cursor).trackWrites);
        this.query((q) => q.using(Canvas).read);
    }
    execute() {
        this.cursors.addedOrChanged.forEach((entity) => {
            const cursor = entity.read(Cursor);
            const { element } = entity.read(Canvas);
            if (element instanceof HTMLCanvasElement) {
                element.style.cursor = cursor.value;
            }
        });
    }
}
//# sourceMappingURL=SetCursor.js.map