import { System } from '@lastolivegames/becsy';
import { GlobalRenderOrder, Parent, Renderable, ZIndex } from '../components';
/**
 * Sort entities by z-index under context.
 *
 * @see https://infinitecanvas.cc/guide/lesson-014#z-index
 */
export class Sort extends System {
    constructor() {
        super();
        // orphans = this.query(
        //   (q) =>
        //     q.addedChangedOrRemoved.with(Renderable).without(Parent, Children)
        //       .trackWrites,
        // );
        // root = this.query(
        //   (q) =>
        //     q.addedChangedOrRemoved
        //       .with(Renderable, Parent)
        //       .without(Children)
        //       .trackWrites.using(GlobalRenderOrder).write,
        // );
        this.renderables = this.query((q) => q.addedChangedOrRemoved.with(Renderable).trackWrites);
        this.zIndex = this.query((q) => q.addedChangedOrRemoved.with(ZIndex).trackWrites);
        this.query((q) => q.with(GlobalRenderOrder).write);
        this.query((q) => q.current.with(Parent).read);
    }
    execute() {
        let i = 1;
        this.renderables.addedChangedOrRemoved.forEach((entity) => {
            if (!entity.has(GlobalRenderOrder)) {
                entity.add(GlobalRenderOrder);
            }
            Object.assign(entity.write(GlobalRenderOrder), {
                value: i++,
            });
        });
        // this.root.addedOrChanged.forEach((entity) => {
        //   console.log(entity);
        // });
    }
}
//# sourceMappingURL=Sort.js.map