import { System } from '@lastolivegames/becsy';
/**
 * Update {@link GlobalTransform} component of entities that aren't in the hierarchy
 * Third party plugins should ensure that this is used in concert with {@link PropagateTransforms}.
 */
export declare class SyncSimpleTransforms extends System {
    queries: import("@lastolivegames/becsy").Query;
    cameras: import("@lastolivegames/becsy").Query;
    orphaned: import("@lastolivegames/becsy").Query;
    constructor();
    private syncTransform;
    execute(): void;
}
/**
 * Update {@link GlobalTransform} component of entities based on entity hierarchy and {@link Transform} components.
 * Use `after` constraints here to ensure that the {@link SyncSimpleTransforms} system has run first.
 * @see https://lastolivegames.github.io/becsy/guide/architecture/systems#execution-order
 */
export declare class PropagateTransforms extends System {
    queries: import("@lastolivegames/becsy").Query;
    constructor();
    execute(): void;
}
