import { vec2 } from 'gl-matrix';
import { Curve } from './curve';
export class LineCurve extends Curve {
    constructor(v1 = vec2.create(), v2 = vec2.create()) {
        super();
        this.v1 = v1;
        this.v2 = v2;
        this.v1 = v1;
        this.v2 = v2;
    }
    getPoint(t, optionalTarget = vec2.create()) {
        const point = optionalTarget;
        if (t === 1) {
            vec2.copy(point, this.v2);
        }
        else {
            vec2.sub(point, vec2.copy(point, this.v2), this.v1);
            vec2.scaleAndAdd(point, this.v1, point, t);
        }
        return point;
    }
    // Line curve is linear, so we can overwrite default getPointAt
    getPointAt(u, optionalTarget) {
        return this.getPoint(u, optionalTarget);
    }
}
//# sourceMappingURL=line-curve.js.map