import { vec2 } from 'gl-matrix';
import { Curve } from './curve';
import { QuadraticBezier } from './interpolations';
export class QuadraticBezierCurve extends Curve {
    constructor(v0 = vec2.create(), v1 = vec2.create(), v2 = vec2.create()) {
        super();
        this.v0 = v0;
        this.v1 = v1;
        this.v2 = v2;
        this.v0 = v0;
        this.v1 = v1;
        this.v2 = v2;
    }
    getPoint(t, optionalTarget = vec2.create()) {
        const point = optionalTarget;
        const { v0, v1, v2 } = this;
        vec2.set(point, QuadraticBezier(t, v0[0], v1[0], v2[0]), QuadraticBezier(t, v0[1], v1[1], v2[1]));
        return point;
    }
    // Line curve is linear, so we can overwrite default getPointAt
    getPointAt(u, optionalTarget) {
        return this.getPoint(u, optionalTarget);
    }
}
//# sourceMappingURL=quadratic-bezier-curve.js.map