import { Path } from './path';
import { OpSet } from 'roughjs/bin/core';
export declare class ShapePath {
    currentPath: Path | null;
    subPaths: Path[];
    constructor();
    moveTo(x: number, y: number): this;
    lineTo(x: number, y: number): this;
    quadraticCurveTo(aCPx: number, aCPy: number, aX: number, aY: number): this;
    bezierCurveTo(aCP1x: number, aCP1y: number, aCP2x: number, aCP2y: number, aX: number, aY: number): this;
}
export declare function parsePath(d: string | OpSet): ShapePath;
/**
 * @see https://github.com/mrdoob/three.js/blob/dev/src/extras/ShapeUtils.js#L7
 */
export declare function area(contour: [number, number][]): number;
/**
 * Use canvas coordinate system, the area is positive if the points are clockwise.
 * @see https://github.com/mrdoob/three.js/blob/dev/src/extras/ShapeUtils.js#L22C9-L26C3
 */
export declare function isClockWise(pts: [number, number][]): boolean;
