import type { GlyphMetrics, StyleGlyph } from './alpha-image';
import { RGBAImage } from './alpha-image';
export declare const glyphPadding = 1;
type Rect = {
    x: number;
    y: number;
    w: number;
    h: number;
};
export type GlyphPosition = {
    rect: Rect;
    metrics: GlyphMetrics;
};
export type GlyphPositions = Record<string, Record<string, GlyphPosition>>;
/**
 * Merge SDFs into a large squared atlas with `potpack`,
 * because on WebGL1 context, all textures are resized to a power of two to produce the best quality.
 *
 * @see https://doc.babylonjs.com/advanced_topics/webGL2#power-of-two-textures
 */
export declare class GlyphAtlas {
    image: RGBAImage;
    positions: GlyphPositions;
    constructor(stacks: Record<string, Record<string, StyleGlyph>>);
}
export {};
