"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddChild = void 0;
const components_1 = require("../components");
class AddChild {
    constructor(parent, child) {
        this.parent = parent;
        this.child = child;
    }
    apply(system) {
        if (!this.parent.has(components_1.Parent)) {
            this.parent.add(components_1.Parent);
        }
        // @see https://lastolivegames.github.io/becsy/guide/architecture/components.html#referencing-entities
        this.child.add(components_1.Children, {
            parent: this.parent,
        });
        // TODO: emit ADD_CHILD event.
    }
}
exports.AddChild = AddChild;
//# sourceMappingURL=AddChild.js.map