"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Insert = void 0;
const components_1 = require("../components");
/**
 * A [`Command`] that adds the components in a [`Bundle`] to an entity.
 */
class Insert {
    constructor(id, bundles) {
        this.id = id;
        this.bundles = bundles;
    }
    apply(system) {
        this.bundles.forEach((bundle) => {
            this.addBundle(bundle);
        });
    }
    addBundle(bundle) {
        // Add bundle.
        if (bundle instanceof components_1.Bundle) {
            Object.keys(bundle).forEach((key) => {
                if (bundle[key] instanceof components_1.Bundle) {
                    this.addBundle(bundle[key]);
                }
                else if (bundle[key]) {
                    // @ts-ignore
                    this.id.add(bundle[key].constructor, bundle[key]);
                }
            });
        }
        else {
            // Add component.
            // @ts-ignore
            this.id.add(bundle.constructor, bundle);
        }
    }
}
exports.Insert = Insert;
//# sourceMappingURL=Insert.js.map