"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Canvas = exports.Pen = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const Camera_1 = require("./camera/Camera");
const Input_1 = require("./Input");
const Screenshot_1 = require("./Screenshot");
var Pen;
(function (Pen) {
    Pen["SELECT"] = "select";
    Pen["HAND"] = "hand";
    Pen["DRAW_RECT"] = "draw-rect";
})(Pen || (exports.Pen = Pen = {}));
class Canvas {
    constructor(canvas) {
        Object.assign(this, canvas);
    }
}
exports.Canvas = Canvas;
__decorate([
    becsy_1.field.object
], Canvas.prototype, "element", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Canvas.prototype, "width", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Canvas.prototype, "height", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.staticString(['webgl', 'webgpu']), default: 'webgl' })
], Canvas.prototype, "renderer", void 0);
__decorate([
    becsy_1.field.object
], Canvas.prototype, "shaderCompilerPath", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 1 })
], Canvas.prototype, "devicePixelRatio", void 0);
__decorate([
    (0, becsy_1.field)({
        type: becsy_1.Type.staticString([Pen.SELECT, Pen.HAND, Pen.DRAW_RECT]),
        default: Pen.HAND,
    })
], Canvas.prototype, "pen", void 0);
__decorate([
    becsy_1.field.backrefs(Camera_1.Camera, 'canvas')
], Canvas.prototype, "cameras", void 0);
__decorate([
    becsy_1.field.backrefs(Input_1.InputPoint, 'canvas')
], Canvas.prototype, "inputPoints", void 0);
__decorate([
    becsy_1.field.backrefs(Screenshot_1.Screenshot, 'canvas')
], Canvas.prototype, "screenshots", void 0);
__decorate([
    becsy_1.field.backrefs(Screenshot_1.VectorScreenshotRequest, 'canvas')
], Canvas.prototype, "vectorScreenshotRequests", void 0);
__decorate([
    becsy_1.field.backrefs(Screenshot_1.RasterScreenshotRequest, 'canvas')
], Canvas.prototype, "rasterScreenshotRequests", void 0);
//# sourceMappingURL=Canvas.js.map