import { Mat3 } from '../math/Mat3';
export declare class ComputedCamera {
    /**
     * x in canvas space
     */
    x: number;
    /**
     * y in canvas space
     */
    y: number;
    /**
     * rotation in canvas space
     */
    rotation: number;
    /**
     * Zoom factor of the camera, default is 1.
     * @see https://threejs.org/docs/#api/en/cameras/OrthographicCamera.zoom
     */
    zoom: number;
    /**
     * Projection matrix.
     */
    projectionMatrix: Mat3;
    /**
     * Invert matrix in world space.
     */
    viewMatrix: Mat3;
    /**
     * projectionMatrix * viewMatrix
     */
    viewProjectionMatrix: Mat3;
    /**
     * Invert viewProjectionMatrix.
     */
    viewProjectionMatrixInv: Mat3;
}
