"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Circle = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const math_1 = require("../math");
const utils_1 = require("../../utils");
/**
 * @see https://docs.rs/bevy/latest/bevy/math/prelude/struct.Circle.html
 */
class Circle {
    static getGeometryBounds(circle) {
        const { cx, cy, r } = circle;
        return new math_1.AABB(cx - r, cy - r, cx + r, cy + r);
    }
    static getRenderBounds(circle, stroke) {
        const { cx, cy, r } = circle;
        const offset = (0, utils_1.strokeOffset)(stroke);
        return new math_1.AABB(cx - r - offset, cy - r - offset, cx + r + offset, cy + r + offset);
    }
    constructor(props) {
        this.cx = props === null || props === void 0 ? void 0 : props.cx;
        this.cy = props === null || props === void 0 ? void 0 : props.cy;
        this.r = props === null || props === void 0 ? void 0 : props.r;
    }
}
exports.Circle = Circle;
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Circle.prototype, "cx", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Circle.prototype, "cy", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Circle.prototype, "r", void 0);
//# sourceMappingURL=Circle.js.map