"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ellipse = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const math_1 = require("../math");
const utils_1 = require("../../utils");
/**
 * Used to create ellipses based on a center coordinate, and both their x and y radius.
 * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Element/ellipse
 */
class Ellipse {
    static getGeometryBounds(ellipse) {
        const { cx, cy, rx, ry } = ellipse;
        return new math_1.AABB(cx - rx, cy - ry, cx + rx, cy + ry);
    }
    static getRenderBounds(ellipse, stroke) {
        const { cx, cy, rx, ry } = ellipse;
        const offset = (0, utils_1.strokeOffset)(stroke);
        return new math_1.AABB(cx - rx - offset, cy - ry - offset, cx + rx + offset, cy + ry + offset);
    }
    constructor(props) {
        this.cx = props === null || props === void 0 ? void 0 : props.cx;
        this.cy = props === null || props === void 0 ? void 0 : props.cy;
        this.rx = props === null || props === void 0 ? void 0 : props.rx;
        this.ry = props === null || props === void 0 ? void 0 : props.ry;
    }
}
exports.Ellipse = Ellipse;
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Ellipse.prototype, "cx", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Ellipse.prototype, "cy", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Ellipse.prototype, "rx", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Ellipse.prototype, "ry", void 0);
//# sourceMappingURL=Ellipse.js.map