import { Type } from '@lastolivegames/becsy';
import { Mat3 } from './Mat3';
/**
 * Axis-Aligned Bounding Box
 */
export declare class AABB {
    /**
     * The minimum x coordinate of the bounding box.
     */
    minX: number;
    /**
     * The minimum y coordinate of the bounding box.
     */
    minY: number;
    /**
     * The maximum x coordinate of the bounding box.
     */
    maxX: number;
    /**
     * The maximum y coordinate of the bounding box.
     */
    maxY: number;
    /**
     * The transformation matrix of the bounding box.
     */
    matrix: Mat3;
    constructor(minX?: number, minY?: number, maxX?: number, maxY?: number, matrix?: Mat3);
    addBounds(bounds: AABB, matrix?: Mat3): void;
    addFrame(x0: number, y0: number, x1: number, y1: number, matrix?: Mat3): void;
}
export declare const aabbType: Type<number[]>;
