"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.aabbType = exports.AABB = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const Mat3_1 = require("./Mat3");
/**
 * Axis-Aligned Bounding Box
 */
class AABB {
    constructor(minX = Infinity, minY = Infinity, maxX = -Infinity, maxY = -Infinity, matrix = Mat3_1.Mat3.IDENTITY) {
        this.minX = minX;
        this.minY = minY;
        this.maxX = maxX;
        this.maxY = maxY;
        this.matrix = matrix;
    }
    addBounds(bounds, matrix) {
        this.addFrame(bounds.minX, bounds.minY, bounds.maxX, bounds.maxY, matrix || this.matrix);
    }
    addFrame(x0, y0, x1, y1, matrix) {
        matrix || (matrix = this.matrix);
        const a = matrix.m00;
        const b = matrix.m01;
        const c = matrix.m10;
        const d = matrix.m11;
        const tx = matrix.m20;
        const ty = matrix.m21;
        let minX = this.minX;
        let minY = this.minY;
        let maxX = this.maxX;
        let maxY = this.maxY;
        let x = a * x0 + c * y0 + tx;
        let y = b * x0 + d * y0 + ty;
        if (x < minX)
            minX = x;
        if (y < minY)
            minY = y;
        if (x > maxX)
            maxX = x;
        if (y > maxY)
            maxY = y;
        x = a * x1 + c * y0 + tx;
        y = b * x1 + d * y0 + ty;
        if (x < minX)
            minX = x;
        if (y < minY)
            minY = y;
        if (x > maxX)
            maxX = x;
        if (y > maxY)
            maxY = y;
        x = a * x0 + c * y1 + tx;
        y = b * x0 + d * y1 + ty;
        if (x < minX)
            minX = x;
        if (y < minY)
            minY = y;
        if (x > maxX)
            maxX = x;
        if (y > maxY)
            maxY = y;
        x = a * x1 + c * y1 + tx;
        y = b * x1 + d * y1 + ty;
        if (x < minX)
            minX = x;
        if (y < minY)
            minY = y;
        if (x > maxX)
            maxX = x;
        if (y > maxY)
            maxY = y;
        this.minX = minX;
        this.minY = minY;
        this.maxX = maxX;
        this.maxY = maxY;
    }
}
exports.AABB = AABB;
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: Infinity })
], AABB.prototype, "minX", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: Infinity })
], AABB.prototype, "minY", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: -Infinity })
], AABB.prototype, "maxX", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: -Infinity })
], AABB.prototype, "maxY", void 0);
__decorate([
    (0, becsy_1.field)({ type: Mat3_1.m3Type, default: Mat3_1.Mat3.IDENTITY })
], AABB.prototype, "matrix", void 0);
exports.aabbType = becsy_1.Type.vector(becsy_1.Type.float32, ['minX', 'minY', 'maxX', 'maxY'], AABB);
//# sourceMappingURL=AABB.js.map