"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.v3Type = exports.Vec3 = void 0;
const becsy_1 = require("@lastolivegames/becsy");
// import { Vec2 } from './Vec2';
/**
 * A 3-dimensional vector.
 *
 * @see https://lastolivegames.github.io/becsy/guide/architecture/components#numeric-vectors
 */
class Vec3 {
    static splat(v) {
        return new Vec3(v, v, v);
    }
    /**
     * Creates a new vector from an array.
     */
    static from_array(a) {
        return new Vec3(a[0], a[1], a[2]);
    }
    static copy(a) {
        return new Vec3(a.x, a.y, a.z);
    }
    constructor(x, y, z) {
        this.x = x !== null && x !== void 0 ? x : 0;
        this.y = y !== null && y !== void 0 ? y : 0;
        this.z = z !== null && z !== void 0 ? z : 0;
    }
    // /**
    //  * `[x, y, z]`
    //  */
    // to_array(): [number, number, number] {
    //   return [this.x, this.y, this.z];
    // }
    xxx() {
        return new Vec3(this.x, this.x, this.x);
    }
    yyy() {
        return new Vec3(this.y, this.y, this.y);
    }
    zzz() {
        return new Vec3(this.z, this.z, this.z);
    }
    // xy() {
    //   return new Vec2(this.x, this.y);
    // }
    // /**
    //  * Computes the length of `self`.
    //  */
    // _length() {
    //   return Math.sqrt(this.dot(this));
    // }
    // /**
    //  * Computes the dot product of `self` and `rhs`.
    //  */
    // dot(rhs: Vec3) {
    //   return this.x * rhs.x + this.y * rhs.y + this.z * rhs.z;
    // }
    // /**
    //  * Computes the cross product of `self` and `rhs`.
    //  */
    // cross(rhs: Vec3) {
    //   return new Vec3(
    //     this.y * rhs.z - this.z * rhs.y,
    //     this.z * rhs.x - this.x * rhs.z,
    //     this.x * rhs.y - this.y * rhs.x,
    //   );
    // }
    // /**
    //  * Returns a vector containing the minimum values for each element of `self` and `rhs`.
    //  */
    // min(rhs: Vec3) {
    //   return new Vec3(
    //     Math.min(this.x, rhs.x),
    //     Math.min(this.y, rhs.y),
    //     Math.min(this.z, rhs.z),
    //   );
    // }
    // /**
    //  * Returns a vector containing the maximum values for each element of `self` and `rhs`.
    //  */
    // max(rhs: Vec3) {
    //   return new Vec3(
    //     Math.max(this.x, rhs.x),
    //     Math.max(this.y, rhs.y),
    //     Math.max(this.z, rhs.z),
    //   );
    // }
    // abs() {
    //   return new Vec3(Math.abs(this.x), Math.abs(this.y), Math.abs(this.z));
    // }
    // neg() {
    //   return this.mul(-1);
    // }
    add(rhs) {
        if (typeof rhs === 'number') {
            return new Vec3(this.x + rhs, this.y + rhs, this.z + rhs);
        }
        return new Vec3(this.x + rhs.x, this.y + rhs.y, this.z + rhs.z);
    }
    // add_assign(rhs: number | Vec3) {
    //   if (typeof rhs === 'number') {
    //     this.x += rhs;
    //     this.y += rhs;
    //     this.z += rhs;
    //   } else {
    //     this.x += rhs.x;
    //     this.y += rhs.y;
    //     this.z += rhs.z;
    //   }
    //   return this;
    // }
    // sub(rhs: number | Vec3) {
    //   if (typeof rhs === 'number') {
    //     return new Vec3(this.x - rhs, this.y - rhs, this.z - rhs);
    //   }
    //   return new Vec3(this.x - rhs.x, this.y - rhs.y, this.z - rhs.z);
    // }
    // sub_assign(rhs: number | Vec3) {
    //   if (typeof rhs === 'number') {
    //     this.x -= rhs;
    //     this.y -= rhs;
    //     this.z -= rhs;
    //   } else {
    //     this.x -= rhs.x;
    //     this.y -= rhs.y;
    //     this.z -= rhs.z;
    //   }
    //   return this;
    // }
    mul(rhs) {
        if (typeof rhs === 'number') {
            return new Vec3(this.x * rhs, this.y * rhs, this.z * rhs);
        }
        return new Vec3(this.x * rhs.x, this.y * rhs.y, this.z * rhs.z);
    }
}
exports.Vec3 = Vec3;
Vec3.ZERO = Vec3.splat(0);
Vec3.ONE = Vec3.splat(1);
Vec3.MAX = Vec3.splat(Number.MAX_VALUE);
Vec3.MIN = Vec3.splat(Number.MIN_VALUE);
Vec3.NEG_Z = new Vec3(0, 0, -1);
Vec3.X = new Vec3(1, 0, 0);
Vec3.Y = new Vec3(0, 1, 0);
Vec3.Z = new Vec3(0, 0, 1);
exports.v3Type = becsy_1.Type.vector(becsy_1.Type.float32, ['x', 'y', 'z'], Vec3);
//# sourceMappingURL=Vec3.js.map