"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Transform = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const Vec2_1 = require("../math/Vec2");
/**
 * A 2D transform.
 * @see https://github.com/tim-blackbird/bevy_mod_transform2d
 *
 * @example
 * ```ts
 * // Get the transform
 * const transform = entity.read(Transform);
 *
 * // Set the transform
 * entity.write(Transform).translation.x = 100;
 * ```
 */
class Transform {
    constructor(props) {
        var _a, _b, _c, _d, _e;
        this.translation = (props === null || props === void 0 ? void 0 : props.translation)
            ? new Vec2_1.Vec2((_a = props.translation.x) !== null && _a !== void 0 ? _a : 0, (_b = props.translation.y) !== null && _b !== void 0 ? _b : 0)
            : Vec2_1.Vec2.ZERO;
        this.scale = (props === null || props === void 0 ? void 0 : props.scale)
            ? new Vec2_1.Vec2((_c = props.scale.x) !== null && _c !== void 0 ? _c : 1, (_d = props.scale.y) !== null && _d !== void 0 ? _d : 1)
            : Vec2_1.Vec2.ONE;
        this.rotation = (_e = props === null || props === void 0 ? void 0 : props.rotation) !== null && _e !== void 0 ? _e : 0;
    }
}
exports.Transform = Transform;
__decorate([
    (0, becsy_1.field)({ type: Vec2_1.v2Type, default: Vec2_1.Vec2.ZERO })
], Transform.prototype, "translation", void 0);
__decorate([
    (0, becsy_1.field)({ type: Vec2_1.v2Type, default: Vec2_1.Vec2.ONE })
], Transform.prototype, "scale", void 0);
__decorate([
    (0, becsy_1.field)({ type: becsy_1.Type.float32, default: 0 })
], Transform.prototype, "rotation", void 0);
//# sourceMappingURL=Transform.js.map