"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrowserAdapter = void 0;
exports.BrowserAdapter = {
    createCanvas: (width, height) => {
        const canvas = document.createElement('canvas');
        canvas.width = width;
        canvas.height = height;
        return canvas;
    },
    createTexImageSource: (canvas) => canvas,
    getDocument: () => document,
    getXMLSerializer: () => new XMLSerializer(),
    getDOMParser: () => new DOMParser(),
    splitGraphemes: (s) => {
        if (typeof (Intl === null || Intl === void 0 ? void 0 : Intl.Segmenter) === 'function') {
            const segmenter = new Intl.Segmenter();
            return [...segmenter.segment(s)].map((x) => x.segment);
        }
        return [...s];
    },
    requestAnimationFrame: (callback) => requestAnimationFrame(callback),
    cancelAnimationFrame: (id) => cancelAnimationFrame(id),
};
//# sourceMappingURL=BrowserAdapter.js.map