"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RendererPlugin = void 0;
/**
 * @see https://docs.rs/bevy/latest/bevy/render/struct.RenderPlugin.html
 */
const becsy_1 = require("@lastolivegames/becsy");
const systems_1 = require("../systems");
const components_1 = require("../components");
const RendererPlugin = () => {
    /**
     * Components
     */
    (0, becsy_1.component)(components_1.GPUResource);
    (0, becsy_1.component)(components_1.Renderable);
    (0, becsy_1.component)(components_1.Name);
    (0, becsy_1.component)(components_1.Wireframe);
    (0, becsy_1.component)(components_1.GlobalRenderOrder);
    (0, becsy_1.component)(components_1.ZIndex);
    (0, becsy_1.component)(components_1.Visibility);
    /**
     * Style
     */
    (0, becsy_1.component)(components_1.FillSolid);
    (0, becsy_1.component)(components_1.FillGradient);
    (0, becsy_1.component)(components_1.FillPattern);
    (0, becsy_1.component)(components_1.FillImage);
    (0, becsy_1.component)(components_1.FillTexture);
    (0, becsy_1.component)(components_1.Stroke);
    (0, becsy_1.component)(components_1.Opacity);
    (0, becsy_1.component)(components_1.DropShadow);
    (0, becsy_1.component)(components_1.InnerShadow);
    (0, becsy_1.component)(components_1.Rough);
    /**
     * Geometry
     */
    (0, becsy_1.component)(components_1.Circle);
    (0, becsy_1.component)(components_1.Ellipse);
    (0, becsy_1.component)(components_1.Rect);
    (0, becsy_1.component)(components_1.Polyline);
    (0, becsy_1.component)(components_1.Path);
    (0, becsy_1.component)(components_1.Text);
    (0, becsy_1.component)(components_1.ComputedPoints);
    (0, becsy_1.component)(components_1.ComputedRough);
    (0, becsy_1.component)(components_1.ComputedTextMetrics);
    (0, becsy_1.component)(components_1.ComputedBounds);
    (0, becsy_1.system)(systems_1.StartUp)(systems_1.SetupDevice);
    (0, becsy_1.system)(systems_1.PreUpdate)(systems_1.ComputePoints);
    (0, becsy_1.system)(systems_1.PreUpdate)(systems_1.ComputeRough);
    (0, becsy_1.system)(systems_1.PreUpdate)(systems_1.ComputeTextMetrics);
    (0, becsy_1.system)(systems_1.PreUpdate)(systems_1.ComputeBounds);
    (0, becsy_1.system)(systems_1.PostUpdate)(systems_1.Sort);
    (0, becsy_1.system)(systems_1.PostUpdate)(systems_1.SetCursor);
    (0, becsy_1.system)((s) => s.after(systems_1.ComputeCamera, systems_1.SetupDevice))(systems_1.MeshPipeline);
};
exports.RendererPlugin = RendererPlugin;
//# sourceMappingURL=Renderer.js.map