"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransformPlugin = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const components_1 = require("../components");
const systems_1 = require("../systems");
/**
 * The base plugin for handling {@link Transform} components.
 * @see https://github.com/bevyengine/bevy/blob/06cb5c5fd9436f27ec72a8810c1b5ae90be957e4/crates/bevy_transform/src/plugins.rs#L23
 */
const TransformPlugin = () => {
    (0, becsy_1.component)(components_1.Transform);
    (0, becsy_1.component)(components_1.GlobalTransform);
    (0, becsy_1.system)(systems_1.PostStartUp)(systems_1.SyncSimpleTransforms);
    (0, becsy_1.system)((s) => s.after(systems_1.SyncSimpleTransforms))(systems_1.PropagateTransforms);
};
exports.TransformPlugin = TransformPlugin;
//# sourceMappingURL=Transform.js.map