import { Gradient, Pattern } from '../utils';
type GradientExtraParams = {
    width: number;
    height: number;
    min: [number, number];
};
export declare class TexturePool {
    #private;
    constructor();
    destroy(): void;
    getOrCreatePattern(params: {
        pattern: Pattern;
        width: number;
        height: number;
    }): TexImageSource;
    getOrCreateGradient(params: {
        gradients: Gradient[];
    } & GradientExtraParams): TexImageSource;
    private getOrCreateGradientInternal;
}
export declare function generateGradientKey(params: Gradient & GradientExtraParams): string;
export declare function generatePatternKey(params: {
    pattern: Pattern;
}): string;
export {};
