import { System } from '@lastolivegames/becsy';
import { Text } from '../components';
/**
 * Generates a font style string to use for `TextMetrics.measureFont()`.
 * @param style
 * @returns Font style string, for passing to `TextMetrics.measureFont()`
 */
export declare function fontStringFromTextStyle(style: Partial<Text>): string;
export declare function yOffsetFromTextBaseline(textBaseline: CanvasTextBaseline, fontMetrics: globalThis.TextMetrics & {
    fontSize: number;
}): number;
export declare class ComputeTextMetrics extends System {
    #private;
    texts: import("@lastolivegames/becsy").Query;
    constructor();
    execute(): void;
    private measureFont;
    private measureText;
    /**
     * @see https://github.com/pixijs/pixijs/blob/dev/src/scene/text/canvas/CanvasTextMetrics.ts#L369
     */
    private wordWrap;
    private computeBidi;
    private measureBitmapFont;
    private measureTextInternal;
    private isBreakingSpace;
    private isNewline;
    private trimToBreakable;
    private shouldBreakByKinsokuShorui;
    private trimByKinsokuShorui;
    private canBreakInLastChar;
    private sumTextWidthByCache;
    private findBreakableIndex;
    private getFromCache;
    private collapseSpaces;
    private collapseNewlines;
}
