"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeshPipeline = void 0;
const d3 = __importStar(require("d3-color"));
const becsy_1 = require("@lastolivegames/becsy");
const g_device_api_1 = require("@antv/g-device-api");
const components_1 = require("../components");
const utils_1 = require("../utils");
const GridRenderer_1 = require("./GridRenderer");
const BatchManager_1 = require("./BatchManager");
class MeshPipeline extends becsy_1.System {
    constructor() {
        super();
        this.canvases = this.query((q) => q.current.with(components_1.Canvas).read);
        this.renderables = this.query((q) => q.addedOrChanged.and.removed
            .with(components_1.Renderable)
            .withAny(components_1.Circle, components_1.Ellipse, components_1.Rect, components_1.Polyline, components_1.Path, components_1.Text).trackWrites);
        this.visibilities = this.query((q) => q.addedOrChanged.with(components_1.Visibility).trackWrites);
        // private styles = this.query(
        //   (q) =>
        //     q.addedChangedOrRemoved.withAny(
        //       FillSolid,
        //       FillGradient,
        //       FillPattern,
        //       FillTexture,
        //       FillImage,
        //       Stroke,
        //       Opacity,
        //       InnerShadow,
        //       DropShadow,
        //       Wireframe,
        //       Rough,
        //     ).trackWrites,
        // );
        this.gpuResources = new Map();
        this.pendingRenderables = {};
        this.query((q) => q.current
            .with(components_1.Theme, components_1.Grid, components_1.GPUResource, components_1.Camera, components_1.ComputedCamera, components_1.Children, components_1.Circle, components_1.Ellipse, components_1.Rect, components_1.Polyline, components_1.Path, components_1.ComputedPoints, components_1.GlobalTransform, components_1.Opacity, components_1.Stroke, components_1.InnerShadow, components_1.DropShadow, components_1.Wireframe, components_1.GlobalRenderOrder, components_1.Rough, components_1.ComputedRough, components_1.Text, components_1.ComputedTextMetrics, components_1.FillImage, components_1.FillPattern, components_1.FillGradient, components_1.FillSolid, components_1.FillTexture)
            .read.and.using(components_1.RasterScreenshotRequest, components_1.Screenshot).write);
    }
    *setScreenshotTrigger(canvas, dataURL) {
        if (!canvas.has(components_1.Screenshot)) {
            canvas.add(components_1.Screenshot);
        }
        const screenshot = canvas.write(components_1.Screenshot);
        Object.assign(screenshot, { dataURL });
        yield;
        Object.assign(screenshot, { dataURL: '' });
    }
    renderCamera(canvas, camera) {
        if (!canvas.has(components_1.GPUResource)) {
            return;
        }
        const { swapChain, device, renderTarget, depthRenderTarget, renderCache, texturePool, } = canvas.read(components_1.GPUResource);
        const { enabled, type, encoderOptions, grid } = canvas.has(components_1.RasterScreenshotRequest)
            ? canvas.read(components_1.RasterScreenshotRequest)
            : { enabled: false, type: 'image/png', encoderOptions: 1, grid: false };
        const { width, height } = swapChain.getCanvas();
        const onscreenTexture = swapChain.getOnscreenTexture();
        const shouldRenderGrid = !enabled || grid;
        if (!this.gpuResources.get(camera.__id)) {
            this.gpuResources.set(camera.__id, {
                uniformBuffer: device.createBuffer({
                    viewOrSize: (16 * 3 + 4 * 5) * Float32Array.BYTES_PER_ELEMENT,
                    usage: g_device_api_1.BufferUsage.UNIFORM,
                    hint: g_device_api_1.BufferFrequencyHint.DYNAMIC,
                }),
                uniformLegacyObject: null,
                gridRenderer: new GridRenderer_1.GridRenderer(),
                batchManager: new BatchManager_1.BatchManager(device, renderCache, texturePool),
            });
        }
        const [buffer, legacyObject] = this.updateUniform(canvas, camera, shouldRenderGrid, swapChain);
        this.gpuResources.set(camera.__id, Object.assign(Object.assign({}, this.gpuResources.get(camera.__id)), { uniformLegacyObject: legacyObject }));
        const { uniformBuffer, uniformLegacyObject, gridRenderer, batchManager } = this.gpuResources.get(camera.__id);
        uniformBuffer.setSubData(0, new Uint8Array(buffer.buffer));
        device.beginFrame();
        const renderPass = device.createRenderPass({
            colorAttachment: [renderTarget],
            colorResolveTo: [onscreenTexture],
            colorClearColor: [g_device_api_1.TransparentBlack],
            depthStencilAttachment: depthRenderTarget,
            depthClearValue: 1,
        });
        renderPass.setViewport(0, 0, width, height);
        gridRenderer.render(device, renderPass, uniformBuffer, uniformLegacyObject);
        if (this.pendingRenderables[camera.__id]) {
            this.pendingRenderables[camera.__id].add.forEach((entity) => {
                batchManager.add(entity);
                console.log('add', entity.__id);
            });
            this.pendingRenderables[camera.__id].remove.forEach((entity) => {
                batchManager.remove(entity);
                console.log('remove', entity.__id);
            });
            delete this.pendingRenderables[camera.__id];
        }
        batchManager.flush(renderPass, uniformBuffer, uniformLegacyObject);
        device.submitPass(renderPass);
        device.endFrame();
        if (enabled) {
            const dataURL = swapChain.getCanvas().toDataURL(type, encoderOptions);
            this.setScreenshotTrigger(canvas, dataURL);
        }
    }
    execute() {
        this.canvases.current.forEach((canvas) => {
            const { cameras } = canvas.read(components_1.Canvas);
            cameras.forEach((camera) => {
                this.renderCamera(canvas, camera);
            });
            // let needRender = true;
            // Style changed.
            // (this.computedCameras.addedOrChanged.length ||
            //   this.styles.addedChangedOrRemoved.length ||
            //   this.themes.addedOrChanged.length ||
            //   this.grids.addedOrChanged.length) &&
            //   (needRender = true);
        });
        this.renderables.addedOrChanged.forEach((entity) => {
            const camera = this.getSceneRoot(entity);
            // The gpu resources is not ready for the camera.
            if (!this.pendingRenderables[camera.__id]) {
                this.pendingRenderables[camera.__id] = {
                    add: [],
                    remove: [],
                };
            }
            this.pendingRenderables[camera.__id].add.push(entity);
        });
        this.renderables.removed.forEach((entity) => {
            const camera = this.getSceneRoot(entity);
            this.pendingRenderables[camera.__id].remove.push(entity);
        });
        this.visibilities.addedOrChanged.forEach((entity) => {
            const visibility = entity.read(components_1.Visibility);
            if (!entity.has(components_1.Renderable)) {
                return;
            }
            const camera = this.getSceneRoot(entity);
            if (!this.pendingRenderables[camera.__id]) {
                this.pendingRenderables[camera.__id] = {
                    add: [],
                    remove: [],
                };
            }
            if (visibility.value === 'visible') {
                this.pendingRenderables[camera.__id].add.push(entity);
            }
            else {
                this.pendingRenderables[camera.__id].remove.push(entity);
            }
        });
    }
    finalize() {
        this.gpuResources.forEach(({ gridRenderer, batchManager }) => {
            gridRenderer.destroy();
            batchManager.clear();
            batchManager.destroy();
        });
    }
    getSceneRoot(entity) {
        if (!entity.has(components_1.Children)) {
            return entity;
        }
        const parent = entity.read(components_1.Children).parent;
        if (parent) {
            return this.getSceneRoot(parent);
        }
        return entity;
    }
    updateUniform(canvas, camera, shouldRenderGrid, swapChain) {
        var _a, _b;
        const { mode, colors } = canvas.read(components_1.Theme);
        const { checkboardStyle } = canvas.read(components_1.Grid);
        const computedCamera = camera.read(components_1.ComputedCamera);
        const { width, height } = swapChain.getCanvas();
        const backgroundColor = colors[mode].background;
        const gridColor = colors[mode].grid;
        const { r: br, g: bg, b: bb, opacity: bo, } = ((_a = d3.rgb(backgroundColor)) === null || _a === void 0 ? void 0 : _a.rgb()) || d3.rgb(0, 0, 0, 1);
        const { r: gr, g: gg, b: gb, opacity: go, } = ((_b = d3.rgb(gridColor)) === null || _b === void 0 ? void 0 : _b.rgb()) || d3.rgb(0, 0, 0, 1);
        const { projectionMatrix, viewMatrix, viewProjectionMatrixInv, zoom } = computedCamera;
        const u_ProjectionMatrix = projectionMatrix;
        const u_ViewMatrix = viewMatrix;
        const u_ViewProjectionInvMatrix = viewProjectionMatrixInv;
        const u_BackgroundColor = [br / 255, bg / 255, bb / 255, bo];
        const u_GridColor = [gr / 255, gg / 255, gb / 255, go];
        const u_ZoomScale = zoom;
        const u_CheckboardStyle = shouldRenderGrid
            ? [
                components_1.CheckboardStyle.NONE,
                components_1.CheckboardStyle.GRID,
                components_1.CheckboardStyle.DOTS,
            ].indexOf(checkboardStyle)
            : 0;
        const u_Viewport = [width, height];
        const buffer = new Float32Array([
            ...(0, utils_1.paddingMat3)(u_ProjectionMatrix),
            ...(0, utils_1.paddingMat3)(u_ViewMatrix),
            ...(0, utils_1.paddingMat3)(u_ViewProjectionInvMatrix),
            ...u_BackgroundColor,
            ...u_GridColor,
            u_ZoomScale,
            u_CheckboardStyle,
            ...u_Viewport,
        ]);
        const legacyObject = {
            u_ProjectionMatrix,
            u_ViewMatrix,
            u_ViewProjectionInvMatrix,
            u_BackgroundColor,
            u_GridColor,
            u_ZoomScale,
            u_CheckboardStyle,
            u_Viewport,
        };
        return [buffer, legacyObject];
    }
}
exports.MeshPipeline = MeshPipeline;
__decorate([
    becsy_1.co
], MeshPipeline.prototype, "setScreenshotTrigger", null);
//# sourceMappingURL=MeshPipeline.js.map