"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetCursor = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const components_1 = require("../components");
class SetCursor extends becsy_1.System {
    constructor() {
        super();
        this.cursors = this.query((q) => q.addedOrChanged.with(components_1.Cursor).trackWrites);
        this.query((q) => q.using(components_1.Canvas).read);
    }
    execute() {
        this.cursors.addedOrChanged.forEach((entity) => {
            const cursor = entity.read(components_1.Cursor);
            const { element } = entity.read(components_1.Canvas);
            if (element instanceof HTMLCanvasElement) {
                element.style.cursor = cursor.value;
            }
        });
    }
}
exports.SetCursor = SetCursor;
//# sourceMappingURL=SetCursor.js.map