"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sort = void 0;
const becsy_1 = require("@lastolivegames/becsy");
const components_1 = require("../components");
/**
 * Sort entities by z-index under context.
 *
 * @see https://infinitecanvas.cc/guide/lesson-014#z-index
 */
class Sort extends becsy_1.System {
    constructor() {
        super();
        // orphans = this.query(
        //   (q) =>
        //     q.addedChangedOrRemoved.with(Renderable).without(Parent, Children)
        //       .trackWrites,
        // );
        // root = this.query(
        //   (q) =>
        //     q.addedChangedOrRemoved
        //       .with(Renderable, Parent)
        //       .without(Children)
        //       .trackWrites.using(GlobalRenderOrder).write,
        // );
        this.renderables = this.query((q) => q.addedChangedOrRemoved.with(components_1.Renderable).trackWrites);
        this.zIndex = this.query((q) => q.addedChangedOrRemoved.with(components_1.ZIndex).trackWrites);
        this.query((q) => q.with(components_1.GlobalRenderOrder).write);
        this.query((q) => q.current.with(components_1.Parent).read);
    }
    execute() {
        let i = 1;
        this.renderables.addedChangedOrRemoved.forEach((entity) => {
            if (!entity.has(components_1.GlobalRenderOrder)) {
                entity.add(components_1.GlobalRenderOrder);
            }
            Object.assign(entity.write(components_1.GlobalRenderOrder), {
                value: i++,
            });
        });
        // this.root.addedOrChanged.forEach((entity) => {
        //   console.log(entity);
        // });
    }
}
exports.Sort = Sort;
//# sourceMappingURL=Sort.js.map