"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGlobalThis = exports.isBrowser = void 0;
exports.createSVGElement = createSVGElement;
const adapter_1 = require("../environment/adapter");
exports.isBrowser = typeof window !== 'undefined' && typeof window.document !== 'undefined';
const getGlobalThis = () => {
    if (typeof globalThis !== 'undefined')
        return globalThis;
    if (typeof self !== 'undefined')
        return self;
    if (typeof window !== 'undefined')
        return window;
    // @ts-ignore
    if (typeof global !== 'undefined')
        return global;
    // @ts-ignore
    return {};
    // [!] Error: The 'this' keyword is equivalent to 'undefined' at the top level of an ES module, and has been rewritten
    // @see https://rollupjs.org/troubleshooting/#error-this-is-undefined
    // if (typeof this !== 'undefined') return this;
};
exports.getGlobalThis = getGlobalThis;
function createSVGElement(type) {
    return adapter_1.DOMAdapter.get()
        .getDocument()
        .createElementNS('http://www.w3.org/2000/svg', type);
}
//# sourceMappingURL=browser.js.map