"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CubicBezierCurve = void 0;
const gl_matrix_1 = require("gl-matrix");
const curve_1 = require("./curve");
const interpolations_1 = require("./interpolations");
class CubicBezierCurve extends curve_1.Curve {
    constructor(v0 = gl_matrix_1.vec2.create(), v1 = gl_matrix_1.vec2.create(), v2 = gl_matrix_1.vec2.create(), v3 = gl_matrix_1.vec2.create()) {
        super();
        this.v0 = v0;
        this.v1 = v1;
        this.v2 = v2;
        this.v3 = v3;
        this.v0 = v0;
        this.v1 = v1;
        this.v2 = v2;
        this.v3 = v3;
    }
    getPoint(t, optionalTarget = gl_matrix_1.vec2.create()) {
        const point = optionalTarget;
        const { v0, v1, v2, v3 } = this;
        gl_matrix_1.vec2.set(point, (0, interpolations_1.CubicBezier)(t, v0[0], v1[0], v2[0], v3[0]), (0, interpolations_1.CubicBezier)(t, v0[1], v1[1], v2[1], v3[1]));
        return point;
    }
    // Line curve is linear, so we can overwrite default getPointAt
    getPointAt(u, optionalTarget) {
        return this.getPoint(u, optionalTarget);
    }
}
exports.CubicBezierCurve = CubicBezierCurve;
//# sourceMappingURL=cubic-bezier-curve.js.map