import { vec2 } from 'gl-matrix';
/**
 * @see https://github.com/mrdoob/three.js/blob/dev/src/extras/core/Curve.js
 */
export declare abstract class Curve {
    arcLengthDivisions: number;
    protected needsUpdate: boolean;
    protected cacheArcLengths: number[];
    abstract getPoint(t: number, optionalTarget?: any): vec2;
    getPointAt(u: number, optionalTarget?: any): vec2;
    getPoints(divisions?: number): vec2[];
    getSpacedPoints(divisions?: number): any[];
    getLength(): number;
    getLengths(divisions?: number): number[];
    updateArcLengths(): void;
    getUtoTmapping(u: number, distance?: number): number;
    clone(): any;
    copy(source: Curve): this;
}
