/**
 * Bezier Curves formulas obtained from
 * https://en.wikipedia.org/wiki/B%C3%A9zier_curve
 *
 * @see https://github.com/mrdoob/three.js/blob/dev/src/extras/core/Interpolations.js
 */
declare function CatmullRom(t: number, p0: number, p1: number, p2: number, p3: number): number;
declare function QuadraticBezier(t: any, p0: any, p1: any, p2: any): number;
declare function CubicBezier(t: any, p0: any, p1: any, p2: any, p3: any): number;
export { CatmullRom, QuadraticBezier, CubicBezier };
