"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LineCurve = void 0;
const gl_matrix_1 = require("gl-matrix");
const curve_1 = require("./curve");
class LineCurve extends curve_1.Curve {
    constructor(v1 = gl_matrix_1.vec2.create(), v2 = gl_matrix_1.vec2.create()) {
        super();
        this.v1 = v1;
        this.v2 = v2;
        this.v1 = v1;
        this.v2 = v2;
    }
    getPoint(t, optionalTarget = gl_matrix_1.vec2.create()) {
        const point = optionalTarget;
        if (t === 1) {
            gl_matrix_1.vec2.copy(point, this.v2);
        }
        else {
            gl_matrix_1.vec2.sub(point, gl_matrix_1.vec2.copy(point, this.v2), this.v1);
            gl_matrix_1.vec2.scaleAndAdd(point, this.v1, point, t);
        }
        return point;
    }
    // Line curve is linear, so we can overwrite default getPointAt
    getPointAt(u, optionalTarget) {
        return this.getPoint(u, optionalTarget);
    }
}
exports.LineCurve = LineCurve;
//# sourceMappingURL=line-curve.js.map