export type GlyphMetrics = {
    width: number;
    height: number;
    left: number;
    top: number;
    advance: number;
};
export type StyleGlyph = {
    id: string;
    bitmap: RGBAImage;
    metrics: GlyphMetrics;
};
export type Size = {
    width: number;
    height: number;
};
export type Point = {
    x: number;
    y: number;
};
export declare class RGBAImage {
    width: number;
    height: number;
    data: Uint8Array | Uint8ClampedArray;
    constructor(size: Size, data?: Uint8Array | Uint8ClampedArray);
    static copy(srcImg: RGBAImage, dstImg: RGBAImage, srcPt: Point, dstPt: Point, size: Size): void;
}
