/**
 * @see https://gitlab.com/unconed/use.gpu/-/blob/master/packages/glyph/src/sdf-esdt.ts
 */
import { SDFStage } from './tiny-sdf';
export declare const paintIntoDistanceField: (image: Uint8Array, data: Uint8ClampedArray, w: number, h: number, pad: number, radius: number, cutoff: number) => void;
export declare const paintSubpixelOffsets: (stage: SDFStage, data: Uint8ClampedArray, w: number, h: number, pad: number, relax?: boolean, half?: number | boolean) => void;
export declare const relaxSubpixelOffsets: (stage: SDFStage, data: Uint8ClampedArray, w: number, h: number, pad: number) => void;
export declare const paintIntoRGB: (image: Uint8Array, color: Uint8ClampedArray, xs: Float32Array, ys: Float32Array, w: number, h: number, pad: number) => void;
export declare const paintIntoAlpha: (image: Uint8Array, alpha: Uint8Array | number[], w: number, h: number, pad: number) => void;
export declare const esdt1d: (mask: Float32Array, xs: Float32Array, ys: Float32Array, offset: number, stride: number, length: number, f: Float32Array, z: Float32Array, b: Float32Array, t: Float32Array, v: Uint16Array) => void;
export declare const esdt: (mask: Float32Array, xs: Float32Array, ys: Float32Array, w: number, h: number, f: Float32Array, z: Float32Array, b: Float32Array, t: Float32Array, v: Uint16Array, half?: number) => void;
export declare const resolveSDF: (xo: Float32Array | number[], yo: Float32Array | number[], xi: Float32Array | number[], yi: Float32Array | number[]) => number[];
export declare const glyphToESDT: (data: Uint8ClampedArray, color: Uint8ClampedArray | null, w: number, h: number, pad?: number, radius?: number, cutoff?: number, preprocess?: boolean, postprocess?: boolean) => {
    data: Uint8Array;
    width: number;
    height: number;
};
