import { type GlyphPosition } from './glyph-atlas';
import type { Point } from './alpha-image';
import type { PositionedGlyph } from './glyph-manager';
export type SymbolQuad = {
    tl: Point;
    tr: Point;
    bl: Point;
    br: Point;
    tex: {
        x: number;
        y: number;
        w: number;
        h: number;
    };
};
/**
 * Create the quads used for rendering a text label.
 */
export declare function getGlyphQuads(positionedGlyphs: PositionedGlyph[], positions: Record<string, Record<string, GlyphPosition>>, useMSDF: boolean): SymbolQuad[];
