export declare const glyphToRGBA: (data: Uint8Array, w: number, h: number, pad?: number) => {
    data: Uint8Array<ArrayBuffer>;
    width: number;
    height: number;
};
export declare const INF = 10000000000;
export type SDFStage = {
    outer: Float32Array;
    inner: Float32Array;
    xo: Float32Array;
    yo: Float32Array;
    xi: Float32Array;
    yi: Float32Array;
    f: Float32Array;
    z: Float32Array;
    b: Float32Array;
    t: Float32Array;
    v: Uint16Array;
    size: number;
};
export declare const getSDFStage: (size: number) => {
    outer: Float32Array<ArrayBuffer>;
    inner: Float32Array<ArrayBuffer>;
    xo: Float32Array<ArrayBuffer>;
    yo: Float32Array<ArrayBuffer>;
    xi: Float32Array<ArrayBuffer>;
    yi: Float32Array<ArrayBuffer>;
    f: Float32Array<ArrayBuffer>;
    z: Float32Array<ArrayBuffer>;
    b: Float32Array<ArrayBuffer>;
    t: Float32Array<ArrayBuffer>;
    v: Uint16Array<ArrayBuffer>;
    size: number;
};
export declare class TinySDF {
    ctx: CanvasRenderingContext2D;
    size: number;
    buffer: number;
    cutoff: number;
    radius: number;
    constructor({ fontSize, buffer, radius, cutoff, fontFamily, fontWeight, fontStyle, fill, }?: {
        fontSize?: number;
        buffer?: number;
        radius?: number;
        cutoff?: number;
        fontFamily?: string;
        fontWeight?: string;
        fontStyle?: string;
        fill?: string;
    });
    draw(char: string, esdt?: boolean, color?: boolean): {
        data: Uint8ClampedArray<ArrayBuffer>;
        width: number;
        height: number;
        glyphWidth: number;
        glyphHeight: number;
        glyphTop: number;
        glyphLeft: number;
        glyphAdvance: number;
    } | {
        data: Uint8Array<ArrayBufferLike>;
        width: number;
        height: number;
        glyphWidth: number;
        glyphHeight: number;
        glyphTop: number;
        glyphLeft: number;
        glyphAdvance: number;
    };
}
export declare const edt1d: (grid: Float32Array, offset: number, stride: number, length: number, f: Float32Array, z: Float32Array, v: Uint16Array) => void;
export declare const edt: (data: Float32Array, x0: number, y0: number, width: number, height: number, gridWidth: number, f: Float32Array, z: Float32Array, v: Uint16Array, half?: number) => void;
export declare const isBlack: (x: number) => boolean;
export declare const isWhite: (x: number) => x is 1;
export declare const isSolid: (x: number) => boolean;
export declare const sqr: (x: number) => number;
export declare const seq: (n: number, start?: number, step?: number) => number[];
