"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.randomInteger = void 0;
exports.pointToLine = pointToLine;
exports.bisect = bisect;
const math_1 = require("roughjs/bin/math");
const gl_matrix_1 = require("gl-matrix");
function pointToLine(x1, y1, x2, y2, x, y) {
    const d = [x2 - x1, y2 - y1];
    if (gl_matrix_1.vec2.exactEquals(d, [0, 0])) {
        return Math.sqrt((x - x1) * (x - x1) + (y - y1) * (y - y1));
    }
    const u = [-d[1], d[0]];
    gl_matrix_1.vec2.normalize(u, u);
    const a = [x - x1, y - y1];
    return Math.abs(gl_matrix_1.vec2.dot(a, u));
}
function bisect(norm, norm2, dy) {
    const bisect = gl_matrix_1.vec2.scale(gl_matrix_1.vec2.create(), gl_matrix_1.vec2.add(gl_matrix_1.vec2.create(), norm, norm2), 0.5);
    gl_matrix_1.vec2.scale(bisect, bisect, 1 / gl_matrix_1.vec2.dot(norm, bisect));
    return gl_matrix_1.vec2.scale(bisect, bisect, dy);
}
const random = new math_1.Random(Date.now());
const randomInteger = () => Math.floor(random.next() * Math.pow(2, 31));
exports.randomInteger = randomInteger;
//# sourceMappingURL=math.js.map