import type { Bindings, BindingsDescriptor, Device, InputLayout, InputLayoutDescriptor, Program, ProgramDescriptor, RenderPipeline, RenderPipelineDescriptor, Sampler, SamplerDescriptor } from '@antv/g-device-api';
export declare class RenderCache {
    private device;
    constructor(device: Device);
    private bindingsCache;
    private renderPipelinesCache;
    private inputLayoutsCache;
    private programCache;
    private samplerCache;
    createBindings(descriptor: BindingsDescriptor): Bindings;
    createRenderPipeline(descriptor: RenderPipelineDescriptor): RenderPipeline;
    createInputLayout(descriptor: InputLayoutDescriptor): InputLayout;
    createProgram(descriptor: ProgramDescriptor): Program;
    createSampler(descriptor: SamplerDescriptor): Sampler;
    destroy(): void;
}
