import { SerializedNode } from './type';
export declare function serializeNodesToSVGElements(nodes: SerializedNode[]): SVGElement[];
export declare function camelToKebabCase(str: string): string;
/**
 * Use filter to create inner shadow.
 * @see https://stackoverflow.com/questions/69799051/creating-inner-shadow-in-svg
 * @example
 * ```html
 * <g filter="url(#filter)">
 *   <defs>
 *     <filter id="filter">
 *       <feOffset dx="10" dy="10"/>
 *     </filter>
 *   </defs>
 *   <circle />
 * </g>
 * ```
 */
export declare function exportInnerShadow(attributes: SerializedNode, element: SVGElement, $g: SVGElement): void;
export declare function exportDropShadow(attributes: SerializedNode, element: SVGElement, $g: SVGElement): void;
/**
 * use <text> and <tspan> to render text.
 * @see https://developer.mozilla.org/en-US/docs/Web/SVG/Element/text#example
 */
export declare function exportText(attributes: SerializedNode, $g: SVGElement): void;
